// ------------- * GUI Frames * -------------------
var bgframe;
var gui_frames={};

function gui_setFusionMode(on)
{
	cfg_fusionUI=on;
	if(on)
	{
		color=colors_fusion;
		font =fonts_fusion;
		style=styles_fusion;
		prop =props_fusion;
	}
	else
	{
		color=colors_element;
		font =fonts_element;
		style=styles_element;
		prop =props_element;
	}
}

function has_channels()
{
	var ch_config=mod.getChnConfig();
	var n, len;

	len=ch_config.length;
	for(n=1; n<=64; n++)
		if(n<=len && ch_config.charCodeAt(n-1))
			return true;
	return false;
}
function gui_Create()
{
	var fallback=false;
	var res=host.cfgGetString('scr.resolution', '');
	host.defineResList("XGA:XGA 4:3 1024x768", "720p:720p 16:9 1280x720"/*, "1080p:Fusion 1080p 16:9 1920x1080"*/);
	if(res=='' && !has_channels() && setup_begin()) return;

	if(res=='1080p' && gui.init(1920, 1080))
	{
		gui_setFusionMode(true);
		bgframe=gui.newFrame(null, 0, 0, 1920, 1080, "");
		bgframe.hide();

	// This is the frame where all pages will be displayed
		gui_frames.main=gui.newFrame(bgframe, (1920-640)/2, 100+77+10, 640, 548, '');

		gui_frames.mtrl=gui.newFrame(bgframe, 1920/3-(3*142+2*16)-20-146, 1080-284-20*4-(648-53+27)+5, 4*142+3*12, 648-53+27-17+2+33-4-1, '');
		gui_frames.mtrr=gui.newFrame(bgframe, 1920/3*2+20, 1080-284-20*4-(648-53+27)+5, 4*142+3*12, 648-53+27-17+2+33-4-1, '');

		gui_frames.indt=gui.newFrame(bgframe, (1920-640)/2, 20, 640, 123+40, '');

		gui_frames.indl=gui.newFrame(bgframe, 1920/2-320-20-458, 740, 458, 320, ''); // aligned with meters above
		gui_frames.indr=gui.newFrame(bgframe, 1920/2+320+20, 740, 458, 320, '');

		gui_frames.ctrl=gui.newFrame(bgframe, (1920-640)/2, 1080-110-200-10-1, 640, 220, '');

		gui_frames.cskb=gui.newFrame(gui_frames.ctrl, 0, 0, 640, 220, ''); // Soft Knob Frame
		gui_frames.cind=gui.newFrame(gui_frames.ctrl, 0, 0, 640, 220, ''); // Indi Frame - When Soft Knobs hidden

		host.defineUserLogo("fusion.png", 331, 42);
		gui_indi.logo=gui.newFrame(bgframe, (1920-331)/2, 970+13, 331, 42, "*img/fusion.png");
	}
/*
	if(gui.init(1368, 768))
	{
		gui_setFusionMode(false);
		bgframe=gui.newFrame(null, 0, 0, 1368, 768, "");
		bgframe.hide();

		gui_frames.mtrl=gui.newFrame(bgframe, 86*1+12,         12     , 276, 523, "img/dk_frm_mtr.png");
		gui_frames.indl=gui.newFrame(bgframe, 86*1+12,         12+523 , 275, 229, "img/dk_frm_indi.png");
		gui_frames.main=gui.newFrame(bgframe, 86*2+12+276,     12     , 460, 522, "img/dk_frm_main.png");
		gui_frames.ctrl=gui.newFrame(bgframe, 86*2+12+276,     12+523 , 460, 230, "img/dk_frm_ctrl.png");
		gui_frames.mtrr=gui.newFrame(bgframe, 86*3+12+276+460, 12     , 276, 523, "img/dk_frm_mtr.png");
		gui_frames.indr=gui.newFrame(bgframe, 86*3+12+276+460, 12+523 , 275, 229, "img/dk_frm_indi.png");
	}
*/
	else if(res=='720p' && gui.init(1280, 720))
	{
		gui_setFusionMode(false);
		bgframe=gui.newFrame(null, 0, 0, 1280, 720, "");
		bgframe.hide();

		gui_frames.mtrl=gui.newFrame(bgframe,         64*1+12,            0, 276, 720,    "img/dk_frm_mtr.png");
		gui_frames.indl=gui.newFrame(gui_frames.mtrl, 0,           0+523-16, 275, 229-16, "img/dk_frm_indi.png");
		gui_frames.main=gui.newFrame(bgframe,         64*2+12+276,        0, 460, 720,    "img/dk_frm_main.png");
		gui_frames.ctrl=gui.newFrame(gui_frames.main, 0,           0+523-16, 460, 230-17, "img/dk_frm_ctrl.png");
		gui_frames.mtrr=gui.newFrame(bgframe,         64*3+12+276+460,    0, 276, 720,    "img/dk_frm_mtr.png");
		gui_frames.indr=gui.newFrame(gui_frames.mtrr, 0,           0+523-16, 275, 229-16, "img/dk_frm_indi.png");
	}
	else
	{
		gui_setFusionMode(false);
		gui.init(1024, 768);
		bgframe=gui.newFrame(null, 0, 0, 1024, 768, "");
		bgframe.hide();

		gui_frames.mtrl=gui.newFrame(bgframe, 12,         12     , 276, 523, "img/dk_frm_mtr.png");
		gui_frames.indl=gui.newFrame(bgframe, 12,         12+523 , 275, 229, "img/dk_frm_indi.png");
		gui_frames.main=gui.newFrame(bgframe, 12+276,     12     , 460, 522, "img/dk_frm_main.png");
		gui_frames.ctrl=gui.newFrame(bgframe, 12+276,     12+523 , 460, 230, "img/dk_frm_ctrl.png");
		gui_frames.mtrr=gui.newFrame(bgframe, 12+276+460, 12     , 276, 523, "img/dk_frm_mtr.png");
		gui_frames.indr=gui.newFrame(bgframe, 12+276+460, 12+523 , 275, 229, "img/dk_frm_indi.png");
		if(res!='XGA') fallback=true;
	}

	if(cfg_fusionUI)
		gui.setBgImage("img/bgfusion.png");
	else
	{
		gui.setBgColor(gui.rgb(75,75,75)); //gui.setBgImage("img/bg.png");
		gui_frames.cskb=gui.newFrame(gui_frames.ctrl,  0,  0, 458, 230, '');
		gui_frames.cind=gui.newFrame(gui_frames.ctrl,  0,  0, 458, 230, '');
		//gui_frames.cind=gui.newFrame(gui_frames.ctrl, 38, 34, 364, 144, "img/dk_mon_bg.png");
	}
	gui_frames.cskb.hide();

/* Create GUI Opbjects */
	makeMeters(gui_frames.mtrl, gui_frames.mtrr);
	Gui_CreateKnobSection(gui_frames.cskb);
	Gui_CreateIndiSection();
	Gui_CreateMonitorSection();
	Pages_Init();
	if(fallback) gui_indi.showInfo("Fallback resolution is set, check monitor.");

	bgframe.onKeyEvent=MainKeyEvent;
	bgframe.setInput(true);
	bgframe.show();
}

function gui_SknobsShow()
{
	gui_frames.cind.hide();
	gui_frames.cskb.show();
}
function gui_SknobsHide()
{
	gui_frames.cskb.hide();
	gui_frames.cind.show();
}

function animateCtrl()
{
	var y;

	gui_frames.cskb.show();
	while(1)
	{
		for(y=38; y<38+142; y+=15)
		{
			//gui_frames.cind.moveTo(42,y);
			gui_frames.cskb.moveTo(0, y-38);
			host.sleep(50);
		}
		for(y=38+142; y>38; y-=15)
		{
			//gui_frames.cind.moveTo(42,y);
			gui_frames.cskb.moveTo(0, y-38);
			host.sleep(50);
		}
	}
}

// ------------- * Interactive * -------------------

function findNextCh(ch)
{
	var n;

	for(n=0; n<64; n++)
		if(ch_data[1+(ch+n)%64].exists) return 1+(ch+n)%64;
	return 1;
}
function findPrevCh(ch)
{
	var n;

	for(n=62; n>=0; n--)
		if(ch_data[1+(ch+n)%64].exists) return 1+(ch+n)%64;
	return 1;
}

function MainKeyEvent(x,y,key)
{
	//log.info_f("key %d \'%c\' press at %d,%d", key, key, x, y);

	if(key>=48 && key<=57)
		onDTMFkeyDown(key-48);
	else if(key==46) // '.'
		onDTMFkeyDown(11); // '#'
	else if(key>=2001 && key<=2006)
	{
		if(mod.comboPresent())
			sknobsPress(6+key-2001);
		else
			sknobsPress(key-2001);
	}
	else
		switch(key)
	{
	case 105: // i - IP screen
		activatePage(pages.ip, null);
		break;
	case 109: // m - Monitor Options
		if(page_active==pages.monopt || page_active==pages.monopt2)
			activatePage(pages.monopt2, null);
		else
			activatePage(pages.monopt, null);
		break;
	case 118: // v - Meters
		activatePage(pages.meters, null);
		break;
	case 116: // t - Time
		activatePage(pages.timer, null);
		break;
	case 114: // r - Returns
		activatePage(pages.returns, null);
		break;
	case 120: // x - More Meters
		activatePage(pages.mtrx, null);
		break;
	case 97: // a - Aux Sends
		activatePage(pages.sends, null);
		break;

	case 115: // s - Show
		activatePage(pages.show, null);
		break;
	case 104: // h - Help
		activatePage(pages.help, null);
		break;
	case 112: // p - Sound4
		activatePage(pages.sound4, null);
		break;

	case 99: // c - channel
		activatePage(pages.chopt, findNextCh(0)); // open default option page or close whether option page is opened
		break;
	case 13:   onMasterKeyDown(keys.MstEnter); return;
	case 1000: onMasterKeyDown(keys.MstLeft);  return;
	case 1001: onMasterKeyDown(keys.MstRight); return;
	case 1002: onMasterKeyDown(keys.MstUp);    return;
	case 1003: onMasterKeyDown(keys.MstDown);  return;
	
	case 1006:
		if(('channel' in page_active) && page_active.channel>=1 && page_active.channel<=64)
			chSwitchToChannel(findNextCh(page_active.channel));
		break;
	case 1007:
		if(('channel' in page_active) && page_active.channel>=1 && page_active.channel<=64)
			chSwitchToChannel(findPrevCh(page_active.channel));
		break;
	}
}
