// Monitor Section
var gui_monitors={};

// ------------------------- * Monitor Section * -------------------------

/*
** createMonitorMeter
*/
function createMonitorMeter(frame, x, y, id, eng_id)
{
	var mframe, ml, mr;

	if(cfg_fusionUI)
	{
		mframe=gui.newFrame(frame, x, y, 75, 16, "img/svg/meter_mon_h.svg");
			ml=gui.newMeter(mframe, 0, 0, 75, 7, "img/svg/mbar_mon_h.svg"); ml.setDir(2); ml.setBars(15); ml.setPoints([-500, 0, 0, 15]);
			mr=gui.newMeter(mframe, 0, 9, 75, 7, "img/svg/mbar_mon_h.svg"); mr.setDir(2); mr.setBars(15); mr.setPoints([-500, 0, 0, 15]);
	}
	else
	{
		mframe=gui.newFrame(frame, x, y, 18, 28, "img/dk_meter_mon.png");
			ml=gui.newMeter(mframe, 0, 0, 9, 28, "img/dk_mbar_mon.png"); ml.setBars(7); ml.setPoints([-500, 0, 0, 7]);
			mr=gui.newMeter(mframe, 9, 0, 9, 28, "img/dk_mbar_mon.png"); mr.setBars(7); mr.setPoints([-500, 0, 0, 7]);
	}
	gui.createMeter(id, 4, null, [ml, mr]);
	gui.linkMeter(id, eng_id);
	host.requestMeter(eng_id, true);
	return mframe;
}

function monitorHideKnob()
{
	if(this.vol_visible==1)
	{
		this.vol_knob.hide();
		this.mute_icon.hide();
		this.met.show();
		this.vol_visible=0;
	}
	this.shwTimeout=null;
}

/*
** createMonitorStatus
*/
function createMonitorStatus(frame, x, y, id, eng_id)
{
	var obj={};

	obj.vol_knob=gui.newKnob(frame, x, y, 27, 27, "img/dk_knob_vol.png");
	obj.vol_knob.hide();
	obj.mute_icon=gui.newPicture(frame, x, y, 26, 26, "img/dk_mute_icon.png");
	obj.mute_icon.hide();
	obj.met=createMonitorMeter(frame, x+6, y+1, id, eng_id);

	obj.muted=false;
	obj.vol_val=mon_const.gain_min;
	obj.vol_visible=0;
	obj.ackTimeout=null;
	obj.shwTimeout=null;

	obj.update=function()
	{
		if(this.vol_visible==0)
		{
			this.mute_icon.hide();
			this.met.hide();
			this.vol_knob.show();
			this.vol_visible=1;
		}
		this.vol_knob.setAngle(this.vol_val/1000*280); // Full Turn - 280 degrees
		this.shwTimeout=host.resetTimeout(this.shwTimeout, mon_const.met_restore_time, monitorHideKnob, this);
	};
	obj.setMute=function(mute)
	{
		if(mute)
		{
			this.met.hide();
			this.vol_knob.hide();
			this.mute_icon.show();
			this.vol_visible=2; // 2 indicates mute icon is on
			this.muted=true;
		}
		else
		{
			this.mute_icon.hide();
			this.vol_knob.hide();
			this.met.show();
			this.vol_visible=0;
			this.muted=false;
		}
	};

	return obj;
}

function createFusionMonitorVolume(frame, x, y, id)
{
	var obj={};

	obj.vol_indi=gui.newPicture(frame, x, y, 90, 69, "img/svg/knob_vol_indi.svg");
	obj.mute_icon=gui.newPicture(obj.vol_indi, 19+12, 18+12, 25, 25, "img/svg/mute_icon.svg");
	obj.mute_icon.hide();
	obj.vol_knob=gui.newKnob(obj.vol_indi, 19, 18, 51, 51, "img/svg/knob_mon.svg");

	obj.muted=false;
	obj.vol_val=mon_const.gain_min;
	obj.ackTimeout=null;

	obj.update=function()
	{
		this.vol_indi.setIndex(this.vol_val/1000*23);
		this.vol_knob.setAngle(this.vol_val/1000*230+20);
	};
	obj.setMute=function(mute)
	{
		if(mute)
		{
			this.vol_knob.hide();
			this.mute_icon.show();
			this.muted=true;
		}
		else
		{
			this.mute_icon.hide();
			this.vol_knob.show();
			this.muted=false;
		}
	};

// Interactivity for the Desktop
	obj.vol_knob.id=id;
	obj.vol_knob.setInput(true);
	obj.vol_knob.onMouseWheel=function(x, y, delta) {onMasterRotaryEvent(this.id, -delta, 0);};

	return obj;
}

/*
** Fusion Monitor Block:
** [Monitor Source]
** name       meter
*/
function Gui_CreateFusionMonitorBlock(frame, x, y, name, id, eng_id)
{
	var f;

	f=gui.newFrame(frame, x, y, 196, 51, '');

	f.srcbg=gui.newFrame(f, 0, 0, 196, 28, "img/svg/program_label_bg.svg");
	f.src=gui.newLabel(f.srcbg, 7, 2, 196-2*7, 24, '', {font:fontRegular(12), color:color.lyellow, align:gui.CENTER, valign:gui.MIDDLE});

	f.name=gui.newLabel(f, 0, 33, 112, 18, '', style.monitor_title);
	f.name.setText(name);

	f.meter=createMonitorMeter(f, 121, 32, id, eng_id);
	return f.src;
}

/*
** Fusion Monitor Block:
** [Monitor Source]
** name       meter
*/
function Gui_CreateFusionExtBlock(frame, x, y, name, alignrt, id, eng_id)
{
	var t;

	if(alignrt)
		t=gui.newLabel(frame, x+260-60, y, 60, 22, '', style.lext_rt);
	else
		t=gui.newLabel(frame, x, y, 60, 22, '', style.lext_lt);
	t.setText(name);
	t=gui.newFrame(frame, x, y+22+1, 260, 27, "img/svg/ext_src_bg.svg");
	t=gui.newLabel(t, 5, 2, 250, 23, '', {font:fontRegular(12), color:color.lyellow, align:gui.CENTER, valign:gui.MIDDLE});
	createMonitorMeter(frame, x+(alignrt?0:(260-75)), y+3, id, eng_id);
	return t;
}

/*
** Gui_CreateMonitorSection
*/
function Gui_CreateMonitorSection()
{
	var t;

	gui_monitors.crmo={};
	gui_monitors.crhp={};
	gui_monitors.prev={};
	gui_monitors.stmo={};
	gui_monitors.ext1={};
	gui_monitors.ext2={};

	if(cfg_fusionUI)
	{
	// CR Monitor
		gui.newFrame(gui_frames.indl, 408,  16, 50, 42, "img/svg/monitor.svg");
		gui_monitors.crmo.src=Gui_CreateFusionMonitorBlock(gui_frames.indl, 192,  20, "CR Monitor",     mtrGUI.crmo, mtrEng.crmo);
		gui_monitors.crmo.vol=createFusionMonitorVolume(gui_frames.indl, 30,  10, knobs.MstMon1);
		gui_monitors.crmo.dim=gui.newLabel(gui_frames.indl, 408,  61, 34, 18, '', {font:fontRegular(12), color:color.red, align:gui.LEFT});
		gui_monitors.crmo.dim.setText("Dim");
		gui_monitors.crmo.dim.hide();
	// Headphones
		gui.newFrame(gui_frames.indl, 408, 116, 50, 42, "img/svg/hp.svg");
		gui_monitors.crhp.src=Gui_CreateFusionMonitorBlock(gui_frames.indl, 192, 120, "CR Headphones",     mtrGUI.crhp, mtrEng.crhp);
		gui_monitors.crhp.vol=createFusionMonitorVolume(gui_frames.indl, 30, 110, knobs.MstHP);
	// Preview
		gui.newFrame(gui_frames.indr,  10,  16, 50, 42, "img/svg/speaker.svg");
		gui_monitors.prev.src=Gui_CreateFusionMonitorBlock(gui_frames.indr,  60,  20, "Preview",         mtrGUI.prev, mtrEng.prev);
		gui_monitors.prev.vol=createFusionMonitorVolume(gui_frames.indr, 325,  10, knobs.MstPview);
	// Studio Monitor
		gui.newFrame(gui_frames.indr,  10, 116, 50, 42, "img/svg/monitor.svg");
		gui_monitors.stmo.src=Gui_CreateFusionMonitorBlock(gui_frames.indr,  60, 120, "Studio Monitor", mtrGUI.stmo, mtrEng.stmo);
		gui_monitors.stmo.vol=createFusionMonitorVolume(gui_frames.indr, 325, 110, knobs.MstMon2);
		gui_monitors.stmo.dim=gui.newLabel(gui_frames.indr,  10, 161, 34, 18, '', {font:fontRegular(12), color:color.red, align:gui.LEFT});
		gui_monitors.stmo.dim.setText("Dim");
		gui_monitors.stmo.dim.hide();

	// External 1
		gui_monitors.ext1.src=Gui_CreateFusionExtBlock(gui_frames.indl,  20, 220, "EXT 1", true , mtrGUI.ext1, mtrEng.ext1);
		gui_monitors.ext1.setSrcStatus=function(status) {this.src.setProp('color', (status==2)?color.lyellow:color.red);};
	// External 2
		gui_monitors.ext2.src=Gui_CreateFusionExtBlock(gui_frames.indr, 180, 220, "EXT 2", false, mtrGUI.ext2, mtrEng.ext2);
		gui_monitors.ext2.setSrcStatus=function(status) {this.src.setProp('color', (status==2)?color.lyellow:color.red);};

	// Preview in HP
		t=gui.newLabel(gui_frames.indl, 192, 184, 95, 16, "", style.monitor_title);
		t.setText("Preview to HP");
		gui_monitors.crhp.preview=gui.newLabel(gui_frames.indl, 323, 184, 73, 16, "", style.monitor_title);
		gui_monitors.crhp.prevled=gui.newPicture(gui_frames.indl, 295, 180, 20, 19, "img/svg/icon_preview_hp.svg");
	}
	else
	{
		var frame_monitor=gui.newFrame(gui_frames.cind, 38, 34, 364, 144, "img/dk_mon_bg.png");

	// monitor sources
		gui_monitors.crmo.src=gui.newLabel(frame_monitor,  44,  7, 85, 19, '', prop.monsrc);
		gui_monitors.crhp.src=gui.newLabel(frame_monitor,  44, 59, 85, 19, '', prop.monsrc);
		gui_monitors.stmo.src=gui.newLabel(frame_monitor, 229, 59, 85, 19, '', prop.monsrc);
		gui_monitors.prev.src=gui.newLabel(frame_monitor, 229,  7, 85, 19, '', prop.monsrc);
	// external sources
		gui_monitors.ext1.src=gui.newLabel(frame_monitor,  49, 124, 120, 15, '', prop.extsrc);
		gui_monitors.ext1.setSrcStatus=function(status) {this.src.setProp('color', (status==2)?color.yellow:color.red);};
		gui_monitors.ext2.src=gui.newLabel(frame_monitor, 236, 124, 120, 15, '', prop.extsrc);
		gui_monitors.ext2.setSrcStatus=function(status) {this.src.setProp('color', (status==2)?color.yellow:color.red);};
	// preview HP mode
		gui_monitors.crhp.preview=gui.newLabel(frame_monitor,   15, 102,  44, 13, '', {font:"myriad-roman-10", color:color.labelOFF, align:gui.RIGHT});
		gui_monitors.crhp.prevled=gui.newPicture(frame_monitor, 64, 103,  12, 12, "img/led_blue.png");
	// monitor volume control
		gui_monitors.crmo.vol=createMonitorStatus(frame_monitor, 142,  8, mtrGUI.crmo, mtrEng.crmo);
		gui_monitors.crhp.vol=createMonitorStatus(frame_monitor, 142, 61, mtrGUI.crhp, mtrEng.crhp);
		gui_monitors.prev.vol=createMonitorStatus(frame_monitor, 328,  8, mtrGUI.prev, mtrEng.prev);
		gui_monitors.stmo.vol=createMonitorStatus(frame_monitor, 328, 61, mtrGUI.stmo, mtrEng.stmo);
	// monitor DIM indicators
		gui_monitors.crmo.dim=gui.newPicture(frame_monitor,  37, 30, 16, 8, "img/mon_dim.png");
		gui_monitors.stmo.dim=gui.newPicture(frame_monitor, 224, 82, 16, 8, "img/mon_dim.png");
		gui_monitors.crmo.dim.hide();
		gui_monitors.stmo.dim.hide();
	}
}
