var pages={}; // stores all references to pages && their controls
var page_active=null; // Link to a currently active Page

function Pages_Init()
{
// Create all pages with graphical elements in memory (initially hidden)
	showPageCreate();
	sendsPageCreate();
	returnsPageCreate();
	monsrcPageCreate();
	ipPageCreate();

	timerPageCreate();
	monoptPageCreate();
	monopt2PageCreate();
	hpeqPageCreate();
	metersPageCreate();
	mtrxPageCreate();
	helpPageCreate();
	sound4PageCreate();

	choptPageCreate();
	chsrcPageCreate();
	cheqPageCreate();
	chmicprocPageCreate();
	chpanPageCreate();
	chauxPageCreate();
	chm1PageCreate();

	mainPageCreate();

// Activate Main Page
	page_active=pages.main;
	page_active.frame.show();
}

function Page_Create(id, cls, title)
{
	var p={};

	if(id in pages) log.warning("page with id "+id+" already exists");

	p.id=id;
	p.cls=cls;

	if(cfg_fusionUI)
		p.frame=gui.newFrame(gui_frames.main, 0, 0, 640, 548, cls=='mtrx'?'img/svg/mtrx_pg_bg.svg':'');
	else if(cls=='main')
		p.frame=gui.newFrame(gui_frames.main, 0, 0, 460, 480, '');
	else
		p.frame=gui.newFrame(gui_frames.main, 13, 24, 415, 455, '');
	p.frame.hide();
	p.title=GUI_CreatePageTitle(p.frame, cls, title);
	pages[id]=p; /* Link In */
	return p;
}

function GUI_CreatePageTitle(frm, cls, title)
{
	var t={};

	if(cls=='main' || cls=='mtrx') return null;
	if(cfg_fusionUI)
	{
		t.frame=gui.newFrame(frm, 0, 6, 640, 27, "img/svg/title_label_bg.svg");
		switch(cls)
		{
		case 'chn':
		case 'chopt':
			t.label=gui.newLabel(t.frame, 640/2-420/2, 6, 420, 15, '', style.pg_title);
			t.setChannel=function(channel){this.label.setText("CHANNEL "+channel+" OPTIONS");};
			break;
		case 'mon':
			t.label=gui.newLabel(t.frame, 640/2-420/2, 6, 420, 15, '', style.pg_title);
			t.setTitle=function(tt){this.label.setText("MONITOR OPTIONS: "+tt);};
			t.setTitle(title);
			break;
		case 'mopt':
			t.label=gui.newLabel(t.frame, 640/2-220/2, 6, 220, 15, '', style.pg_title);
			t.label.setText(title);
			t.setTitle=function(tt){};
			break;
		case 'glob':
			t.label=gui.newLabel(t.frame, 640/2-420/2, 6, 420, 15, '', style.pg_title);
			t.setTitle=function(tt){this.label.setText("GLOBAL OPTIONS: "+tt);};
			t.setTitle(title);
			break;
		}
	}
	else
	{
		if(cls!='mopt')
		{
			if(cls=='chopt')
			{
				t.frame=gui.newFrame(frm, 76, 17, 100, 26, "img/page_title.png");
				gui.newFrame(frm, 184, 23, 145, 12, "img/channel_options.png");
			}
			else
				t.frame=gui.newFrame(frm, 157, 56, 100, 26, "img/page_title.png");
			t.label=gui.newLabel(t.frame, 5, 6, 90, 15, '', style.pg_title);
		}
		switch(cls)
		{
		case 'chn':
			gui.newFrame(frm, 135, 32, 145, 12, "img/channel_options.png");
		case 'chopt': /* fall through */
			t.setChannel=function(channel){this.label.setText(host.sprintf("CHANNEL %02d", channel));};
			break;
		case 'mon':
			gui.newFrame(frm, 135, 32, 144, 12, "img/monitor_options.png");
			t.setTitle=function(tt){this.label.setText(tt);};
			t.setTitle(title);
			break;
		case 'mopt':
			gui.newFrame(frm, 135, 20, 144, 12, "img/monitor_options.png");
			t.setTitle=function(tt){};
			break;
		case 'glob':
			gui.newFrame(frm, 140, 32, 135, 12, "img/global_options.png");
			t.setTitle=function(tt){this.label.setText(tt);};
			t.setTitle(title);
			break;
		}
	}
	return t;
}

function GUI_CreatePageSubTitle(frm, title, icon, iw, ih)
{
	var t={};
	t.frame=gui.newFrame(frm, 0, 43, 640, 50, "img/svg/opts_label_bg.svg");
	t.label=gui.newLabel(t.frame,  15, (50-16)/2, 220, 16, '', {font:fontRegular(12), color:color.lyellow, align:gui.LEFT, valign:gui.MIDDLE});
	t.icon =gui.newFrame(t.frame, 609, (50-ih)/2,  iw, ih, icon);
	t.label.setText(title);
}

// -------------------- page functions ------------------------

// opens, hides of updates page data
// channel_nr - optional for channel option pages
function activatePage(a_page, channel_nr)
{
	if(page_active!=a_page)
	{
		var old_page=page_active;
	// close other page && display this
		onClosePage(page_active);
		page_active=a_page;
		onOpenPage(a_page, channel_nr);
		old_page.frame.hide();
		a_page.frame.show();
		page_active=a_page;
		return;
	}
// same page: jump to other channel or close page
	if(('channel' in page_active) && page_active.channel!=channel_nr)
	{
	// update page with new channel information
		onClosePage(page_active);
		onOpenPage(a_page, channel_nr);
	}
	else
	{
	// close this page && return to main
		onClosePage(page_active);
		onOpenPage(pages.main, null);
		page_active.frame.hide();
		pages.main.frame.show();
		page_active=pages.main;
	}
}
function closePage(a_page, channel_nr)
{
	if(page_active!=a_page) return;
	if(('channel' in page_active) && page_active.channel!=channel_nr) return;

// close this page && return to main
	onClosePage(page_active);
	onOpenPage(pages.main, null);
	page_active.frame.hide();
	pages.main.frame.show();
	page_active=pages.main;
}
// if some channel options page is open, switch to different suboption page
// for the same channel
function chSwitchToPage(a_page)
{
	var old_page=page_active;

// check if current page is channel page
	if(!('channel' in old_page) || old_page.channel<1 || old_page.channel>64) return;

// Check lock map
	switch(a_page)
	{
	case pages.chsrc:     if(!mstEnable.chn_src ) return; break;
	case pages.chm1:      if(!mstEnable.chn_feed) return; break;
	case pages.cheq:      if(!mstEnable.chn_eq  ) return; break;
	case pages.chmicproc: if(!mstEnable.chn_eq  ) return; break;
	case pages.chpan:     if(!mstEnable.chn_pan ) return; break;
	case pages.chaux:     if(!mstEnable.chn_aux ) return; break;
	}

// if already open, close and go back to default option view page
	if(old_page==a_page) a_page=pages.chopt;

	onClosePage(old_page);
	page_active=a_page;
	onOpenPage(a_page, old_page.channel);
	old_page.frame.hide();
	a_page.frame.show();
}
// if some channel opt page is open, switch to different channel, but keep the same suboption page
function chSwitchToChannel(channel_nr)
{
	if('channel' in page_active)
	{
		if(page_active==pages.chsrcur)
		{
		// workaround: it would be unwise stay on source unload page when channel is switched
			onClosePage(page_active);
			onOpenPage(pages.chopt, channel_nr);
			page_active.frame.hide();
			pages.chopt.frame.show();
			page_active=pages.chopt;
			return;
		}
		if(page_active==pages.chmicproc && (ch_data[channel_nr].srct==srct.line || ch_data[channel_nr].srct==srct.computer))
		{
		// workaround: close mic-processing page if src_type is line/computer
			onClosePage(page_active); // close micprocessing page - old channel
			onOpenPage(pages.cheq, channel_nr); // open EQ page - new channel
			page_active.frame.hide();
			pages.cheq.frame.show();
			page_active=pages.cheq;
		}
		else
		{
			onClosePage(page_active);
			onOpenPage(page_active, channel_nr);
		}
	}
}

// ------------------------- * Page events * -------------------------

// update page with data from ACL. Turn on lamp on module if necessary
function onOpenPage(a_page, channel_nr)
{
	if('onOpen' in a_page) a_page.onOpen(channel_nr);
// let production code to decide if he needs this page
	prodEnable(channel_nr);
}
// turn off lamp on module
function onClosePage(a_page)
{
	if('onClose' in a_page) a_page.onClose(a_page);
}
function onNumpadDown(num)
{
	if(!('onNumpadDown' in page_active)) return false;
	page_active.onNumpadDown(num);
	return true;
}
