// ------------------------ channel pan page ------------------------

function chpanKnobFocus(on)
{
	var pr=on?prop.Focused:prop.Inactive;

	if(!this.changed) this.val.setProps(pr);
	this.lbl.setProps(pr);
	this.knob.setIndex(on?2:0);
}

function chpanPageCreate()
{
	var p;
	var f, pan_fr;

	p=Page_Create('chpan', 'chn', "");
	f=p.frame;

	if(cfg_fusionUI)
	{
		var lbl;

		p.subtitle=GUI_CreatePageSubTitle(f, "PAN & MODE", "img/svg/icon_pan_and_mode_ylw.svg", 20, 20);
		pan_fr=gui.newFrame(f, 0, 93, 640, 250, "img/svg/ch_edit_pan_bg.svg");
		p.pan=
		{
			val:  gui.newLabel(pan_fr, 20+135-120/2+22/2, 200-23, 120, 14, '', style.value),
			knob: gui.newKnob (pan_fr, 20+135, 200,  22, 22, "img/svg/knob_22px.svg"),
			lbl:  gui.newLabel(pan_fr, 20+135-50/2+22/2, 200+25, 50, 14, '', style.label),
			name: "PAN",
			push: null,
			angle: 0,
			changed: false,
			focus: chpanKnobFocus
		};
		p.pan.lbl.setText("PAN");

		p.mode=
		{
			val:  gui.newLabel(pan_fr, 20+135-70/2+22/2+150, 200-23, 70, 14, '', style.value),
			knob: gui.newKnob (pan_fr, 20+135+150, 200,  22, 22, "img/svg/knob_22px.svg"),
			lbl:  gui.newLabel(pan_fr, 20+135-50/2+22/2+150, 200+25, 50, 14, '', style.label),
			lock: gui.newLabel(pan_fr, 20+135+150+22+5, 200,  14, 14, "img/svg/lock.svg"),
			name: "MODE",
			push: "TAKE",
			angle: 0,
			changed: false,
			focus: chpanKnobFocus
		};
		p.mode.lbl.setText("MODE");

		p.phase=
		{
			val:  gui.newLabel(pan_fr, 20+135-70/2+22/2+150*2, 200-23, 70, 14, '', style.value),
			knob: gui.newKnob (pan_fr, 20+135+150*2, 200,  22, 22, "img/svg/knob_22px.svg"),
			lbl:  gui.newLabel(pan_fr, 20+135-50/2+22/2+150*2, 200+25, 50, 14, '', style.label),
			name: "PHASE",
			push: "TAKE",
			angle: 0,
			changed: false,
			focus: chpanKnobFocus
		};
		p.phase.lbl.setText("PHASE");

		lbl=gui.newLabel(pan_fr, 640/2-258/2-15, 50+12, 15, 20, '', {font:fontSemiBold(12), color:color.white, align:gui.LEFT, valign:gui.MIDDLE});
		lbl.setText("L");
		lbl=gui.newLabel(pan_fr, 640/2-258/2+258, 50+12, 15, 20, '', {font:fontSemiBold(12), color:color.white, align:gui.LEFT, valign:gui.MIDDLE});
		lbl.setText("R");

		p.surface_fr=gui.newFrame(pan_fr, 640/2-258/2, 30, 258, 135, "img/svg/surface_pan_lrg.svg");

		p.ctpan=gui.newPan(p.surface_fr, 0, 0, 258, 135, '');
		p.ctpan.setParams(129-5, 115, "img/svg/pan_ball.svg");
		p.radius=93;
		p.adelta=180/35;
	}
	else
	{
		pan_fr=gui.newFrame(f, 32, 103, 356, 219, "img/ch_edit_pan_bg.png");
		p.pan=
		{
			val:  gui.newLabel(pan_fr, 36, 155, 80, 14, '', prop.value),
			knob: gui.newKnob (pan_fr, 65, 172, 22, 22, "img/knob_22px.png"),
			lbl:  gui.newLabel(pan_fr, 36, 195, 80, 14, '', prop.value),
			name: "PAN",
			push: null,
			angle: 0,
			changed: false,
			focus: chpanKnobFocus
		};
		p.pan.lbl.setText("PAN");

		p.mode=
		{
			val:  gui.newLabel(pan_fr, 124, 155, 100, 14, '', prop.value),
			knob: gui.newKnob (pan_fr, 163, 172,  22, 22, "img/knob_22px.png"),
			lbl:  gui.newLabel(pan_fr, 124, 195, 100, 14, '', prop.value),
			lock: gui.newLabel(pan_fr, 167, 141,  14, 14, "img/lock.png"),
			name: "MODE",
			push: "TAKE",
			angle: 0,
			changed: false,
			focus: chpanKnobFocus
		};
		p.mode.lbl.setText("MODE");

		p.phase=
		{
			val:  gui.newLabel(pan_fr, 249, 155, 60, 14, '', prop.value),
			knob: gui.newKnob (pan_fr, 268, 172, 22, 22, "img/knob_22px.png"),
			lbl:  gui.newLabel(pan_fr, 249, 195, 60, 14, '', prop.value),
			name: "PHASE",
			push: "TAKE",
			angle: 0,
			changed: false,
			focus: chpanKnobFocus
		};
		p.phase.lbl.setText("PHASE");

		p.ctpan=gui.newPan(pan_fr, 107, 46, 140, 84, "");
		p.ctpan.setParams(70, 62, "img/pan_edit_ball.png");
		p.radius=51;
		p.adelta=180/25;
	}

	p.focuslist=[p.pan,p.mode,p.phase];
	p.focus=-1;
	p.setFocus=function(newfocus)
	{
		if(newfocus==this.focus) return;
		if(this.focus in this.focuslist) this.focuslist[this.focus].focus(false);
		this.focus=newfocus;
		if(this.focus in this.focuslist) this.focuslist[this.focus].focus(true);
	}

// softknobs
	p.sknobs6=
	[
		{enabled: true, rot: "PAN"},
		{enabled: true, rot: "MODE",  push: "TAKE"},
		{enabled: true, rot: "PHASE", push: "TAKE"},
		{enabled: false},
		{enabled: false},
		{enabled: true, push: "EXIT", chopt: true}
	];
	p.sknobs3=
	[
		{enabled: false},
		{enabled: false},
		{enabled: true, rot: "FUNCTION", push: "EXIT", chopt: true}
	];

// event functions
	p.onOpen =chpanOnOpen;
	p.onClose=chpanOnClose;
	p.onIndi =chpanIndi;
	p.onSoftKnobRot =chpanOnSoftKnobRot;
	p.onSoftKnobDown=chpanOnSoftKnobDown;
	p.onSoftKnobUp  =chpanOnSoftKnobUp;

	p.adjustPan     =chpanAdjustPan;
	p.onKnobRot     =chpanAdjustPan;
}
function chpanOnOpen(channel_nr)
{
	if(channel_nr==null) return;
	this.channel=channel_nr;
// Indications
	this.title.setChannel(this.channel);
	mod.setChnKeyLed(this.channel, keys.ChnOptions, 255);
	mod.setChnFusionInvert(this.channel, 1);
	mod.setMasterKeyLed(keys.MstChnPan, 255);
// Register receive msg handlers
	rxHandlersCh[this.channel].chpan=this;

	sknobsShow(mod.comboPresent()?this.sknobs3:this.sknobs6);

	this.setFocus(-1);
	sknobsSetOne(8, {angle: 180});
	sknobsSetOne(6, {angleNrm: 0});
	sknobsSetOne(7, {angleNrm: 0});

	var rmsg=host.sendChnCmsgRq(this.channel, {id:"READ", bPANO:0, bMODE:0, bMLCK:0, bPHAS:0, bSRCT:0});
	if(rmsg!=null) this.onIndi(rmsg);
}
function chpanOnClose()
{
	sknobsHide();
// delete receive msg handlers
	delete rxHandlersCh[this.channel].chpan;

	mod.setChnKeyLed(this.channel, keys.ChnOptions, 0);
	mod.setChnFusionInvert(this.channel, 0);
	mod.setMasterKeyLed(keys.MstChnPan, 0);
}
function chpanIndi(chmsg)
{
	if('bSRCT' in chmsg)
	{
		this.srct=chmsg.bSRCT;
		if(srcIsStereo(this.srct))
		{
			this.mode_count =cfg_surroundMode?7:4;
			this.phase_count=4;
		}
		else
		{
			this.mode_count =2;
			this.phase_count=2;
		}
	}
	if('bMODE' in chmsg)
	{
		this.mode.idx=chmsg.bMODE;
		this.mode.val.setText(mode_txt[this.mode.idx]);
		this.mode.changed=false;
		this.mode.focus(this.focus==1);
		this.mode.angle=chpanSetKnobPos(this.mode.knob, this.mode_count-1, this.mode.idx-1);
		sknobsSetOne(1, {angleNrm: this.mode.angle});
		if(this.focus==1)
			sknobsSetOne(6, {angleNrm: this.mode.angle});
	}
	if('bPHAS' in chmsg)
	{
		this.phase.idx=chmsg.bPHAS;
		chpanPhaseSetText(this, this.phase.idx);
		this.phase.changed=false;
		this.phase.focus(this.focus==2);
		this.phase.angle=chpanSetKnobPos(this.phase.knob, this.phase_count-1, this.phase.idx-1);
		sknobsSetOne(2, {angleNrm: this.phase.angle});
		if(this.focus==2)
			sknobsSetOne(6, {angleNrm: this.phase.angle});
	}
	if('wvPANO' in chmsg)
	{
		this.panidx=panGetIdx(chmsg.wvPANO[0], chmsg.wvPANO[1]);
	}
// recalculate PAN on pan change and mode change (mode change can change number of balls)
	if(('wvPANO' in chmsg) || ('bMODE' in chmsg))
	{
	// knob
		this.pan.angle=this.panidx/pan_const.val_table_maxind;
		this.pan.knob.setAngleNrm(this.pan.angle);
		sknobsSetOne(0, {angleNrm: this.pan.angle});
		if(this.focus==0)
			sknobsSetOne(6, {angleNrm: this.pan.angle});
	// balls
		var pan_angle=-90+this.panidx/pan_const.val_table_maxind*180;
		if(srcIsStereo(this.srct) && this.mode.idx==mode_type.stereo)
			this.ctpan.setValues(this.radius, this.radius, pan_angle-this.adelta, pan_angle+this.adelta);
		else
			this.ctpan.setValues(this.radius, -1, pan_angle, 0);

	// val
		var val_l=pan_const.val_table[this.panidx][0];
		var val_r=pan_const.val_table[this.panidx][1];
		var val_l_str=(val_l==pan_const.min_db?"OFF":(val_l/10).toString()+" dB");
		var val_r_str=(val_r==pan_const.min_db?"OFF":(val_r/10).toString()+" dB");
		this.pan.val.setText("L "+val_l_str+", R "+val_r_str);
	}
	if('bMLCK' in chmsg)
	{
		this.mlck=chmsg.bMLCK;
		if(this.mlck==2)
		{
			this.mode.lock.show();
			sknobsSetOne(1, {enabled: false});
			if(this.focus==1)
				sknobsSetOne(6, {enabled: false});
		}
		else
		{
			this.mode.lock.hide();
			if(this.focus==1)
				sknobsSetOne(6, {enabled: true});
		}
	}
}
function chpanAdjustPan(delta)
{
	var newi=clamp(this.panidx+delta, 0, pan_const.val_table_maxind);
	if(newi!=this.panidx) host.sendChnCmsg(this.channel, {id:"WRIN", wvPANO:pan_const.val_table[newi]});
}
function chpanOnSoftKnobRot(idx, delta)
{
	var ctrl, newidx;

	idx--; // FIXME
	if(idx==8)
	{
	// change focus
		this.setFocus(clamp(this.focus+delta, 0, 2));
		sknobsSetOne(8, {angleNrm: this.focus/2});
		ctrl=this.focuslist[this.focus];
		sknobsSetOne(6, {enabled: true, rot: ctrl.name, push: ctrl.push, angleNrm: ctrl.angle});
		if(this.focus==1 && this.mlck==2)
			sknobsSetOne(6, {enabled: false});
		return;
	}

	if(idx==6) idx=this.focus;

	switch(idx)
	{
	case 0:
		this.adjustPan(delta);
		break;
	case 1:
		if(this.mlck!=2)
		{
			newidx=clamp(this.mode.idx+delta, 1, this.mode_count);
			if(this.mode.idx!=newidx)
			{
				this.mode.idx=newidx;
				this.mode.val.setText(mode_txt[this.mode.idx]);
				this.mode.val.setProps(prop.Changed);
				this.mode.angle=chpanSetKnobPos(this.mode.knob, this.mode_count-1, this.mode.idx-1);
				sknobsSetOne(1, {angleNrm: this.mode.angle});
			}
		}
		break;
	case 2:
		newidx=clamp(this.phase.idx+delta, 1, this.phase_count);
		if(this.phase.idx!=newidx)
		{
			this.phase.idx=newidx;
			chpanPhaseSetText(this, this.phase.idx);
			this.phase.val.setProps(prop.Changed);
			this.phase.angle=chpanSetKnobPos(this.phase.knob, this.phase_count-1, this.phase.idx-1);
			sknobsSetOne(2, {angleNrm: this.phase.angle});
		}
		break;
	}
}
function chpanOnSoftKnobDown(idx)
{
	idx--; // FIXME
	if(idx==6) idx=this.focus;

	switch(idx)
	{
	case 1: // mode
		if(this.mlck!=2)
			host.sendChnCmsg(this.channel, {id:"WRIN", bMODE:this.mode.idx});
		break;
	case 2: // phase
		host.sendChnCmsg(this.channel, {id:"WRIN", bPHAS:this.phase.idx});
		break
	}
}
function chpanOnSoftKnobUp(idx)
{
	switch(idx)
	{
	case 6:
	case 9: // Combo3
		chSwitchToPage(this); // will effectively go back to chopt page
		break;
	}
}
function chpanPhaseSetText(p, phas)
{
	p.phase.val.setText(srcIsStereo(p.srct)?phase_txt_stereo[phas]:phase_txt_mono[phas]);
}
// ind form 0 to max value
// maxind - indicates max possible values minus 1
function chpanSetKnobPos(knob, maxind, ind)
{
	var angle=ind/maxind;
	knob.setAngleNrm(angle);
	return angle;
}
