// ------------------------ global monopt page ------------------------
function monoptFocusFusion(on)
{
	var pr=on?prop.Focused:prop.Inactive;

	this.frm.setBg(on?this.activebg:this.passivebg);
	this.list.setProps({bordercolor:pr.color});
}
function monoptFocus(on)
{
	var pr=on?prop.Focused:prop.Inactive;

	this.knob.setIndex(on?1:0);
	this.title.setProps(pr);
	this.list.setProps({bordercolor:pr.color});
}

function monoptPageCreate()
{
	var p;
	var f, fr, k;

	p=Page_Create('monopt', 'mopt', "MONITOR OPTIONS");
	f=p.frame;

	const x=7, y=8, dx=5, dy=5; // Title position

	if(!cfg_fusionUI) fr=gui.newFrame(f, 53, 37, 317, 405, "img/monopt_menu.png");

// Talk to Monitors Levels
	p.lev=[];
	if(cfg_fusionUI)
	{
		fr=gui.newFrame(f, 0, 40, 312, 120, "img/svg/mon_opt_bg_passive.svg");
		gui.newFrame(fr, 312-10-21, 12, 21, 13, "img/svg/icon_mic2.svg");
		fr.title=gui.newLabel(fr, x, y, 228, 16, '', prop.value_left_medium);
		fr.title.setText("TALK TO CR MONITOR");
		p.lev[0]=knobCreate(fr, 296/2-50-25, 37, 50, "TALK");
		p.lev[1]=knobCreate(fr, 296/2+25, 37, 50, "DIM");

		fr=gui.newFrame(f, 640-312, 40, 312, 120, "img/svg/mon_opt_bg_passive.svg");
		gui.newFrame(fr, 312-10-21, 12, 21, 13, "img/svg/icon_mic2.svg");
		fr.title=gui.newLabel(fr, x, y, 228, 16, '', prop.value_left_medium);
		fr.title.setText("TALK TO STUDIO MONITOR");
		p.lev[2]=knobCreate(fr, 296/2-40/2, 37, 50, "DIM");
	}
	else
	{
		p.lev[0]=knobCreate(fr,  20, 17, 40, "TALK");
		p.lev[1]=knobCreate(fr,  88, 17, 40, "DIM");
		p.lev[2]=knobCreate(fr, 215, 17, 40, "DIM");
	}

// Headphone Follow Monitors
	if(cfg_fusionUI)
	{
		fr=gui.newFrame(f, 0, 40+120+9, 312, 120, "img/svg/mon_opt_bg_passive.svg");
		gui.newFrame(fr, 312-10-25, 12, 25, 10, "img/svg/icon_links.svg");
		p.hpfollow=
		{
			name: "HP LINK",
			title: gui.newLabel(fr, x, y, 238, 16, '', prop.value_left_medium),
			list:  gui.newList (fr, 312/2-292/2, y+dy+14+11+4, 292, 44, '', prop.list),
			focus: monoptFocusFusion,
			frm:   fr,
			activebg: "img/svg/mon_opt_bg_active.svg",
			passivebg: "img/svg/mon_opt_bg_passive.svg"
		};
	}
	else
	{
		p.hpfollow=
		{
			name: "HP LINK",
			title: gui.newLabel (fr, 27,  80, 258, 14, '', prop.value_left),
			knob: gui.newPicture(fr, 13, 106,  18, 18, "img/pknob_18px.png"),
			list: gui.newList   (fr, 45,  98, 258, 32, '', prop.list),
			focus: monoptFocus
		};
	}
	p.hpfollow.list.setProps({border:1});
	p.hpfollow.title.setText("HEADPHONES FOLLOW MONITORS");
	p.hpfollow.list.insert("LINKED (Monitor selection to Headphones)", 1);
	p.hpfollow.list.insert("UNLINKED (Push Preview for HP selection)", 2);
	p.hpfollow.list.select(0);
// Headphone Processing
	if(cfg_fusionUI)
	{
		fr=gui.newFrame(f, 640-312, 40+120+9, 312, 120, "img/svg/mon_opt_bg_passive.svg");
		gui.newFrame(fr, 312-10-25, 12, 25, 13, "img/svg/icon_dynamics.svg");
		p.hpproc=
		{
			name: "HP PROC",
			title: gui.newLabel(fr, x, y, 228, 16, '', prop.value_left_medium),
			list:  gui.newList (fr, 312/2-292/2, y+dy+14+11+4, 292, 44, '', prop.list),
			focus: monoptFocusFusion,
			frm: fr,
			activebg: "img/svg/mon_opt_bg_active.svg",
			passivebg: "img/svg/mon_opt_bg_passive.svg"
		};
	}
	else
	{
		p.hpproc=
		{
			name: "HP PROC",
			title: gui.newLabel (fr, 27, 145, 258, 14, '', prop.value_left),
			knob: gui.newPicture(fr, 13, 180,  18, 18, "img/pknob_18px.png"),
			list: gui.newList   (fr, 45, 160, 225, 60, '', prop.list),
			focus: monoptFocus
		};
	}
	p.hpproc.list.setProps({border:1});
	p.hpproc.title.setText("HEADPHONE PROCESSING");
/* TODO: not implemented
	p.hpproc.list.insert("NONE", 0);
	p.hpproc.list.insert("ANY SELECTION (CRHP ONLY)", 1);
	p.hpproc.list.insert("PGM1 TO EXT2 ONLY (ALL MONITORS)", 2);
*/
	p.hpproc.list.insert("CHANGE SETTINGS...", 999);
	p.hpproc.list.select(0);
// Preview to Headphones
	if(cfg_fusionUI)
	{
		fr=gui.newFrame(f, 0, 40+(120+9)*2, 640, 120, "img/svg/pv_to_hp_bg.svg");
		gui.newFrame(fr, 640-10-20, 12, 20, 20, "img/svg/icon_pv2hp_20px.svg");
		p.hpprev=
		{
			name: "HP PREV",
			title: gui.newLabel(fr, x, y, 258, 16, '', prop.value_left_medium),
			list:  gui.newList (fr, 640/2-620/2, y+dy+14+4+3, 620, 64, '', prop.list),
			focus: monoptFocusFusion,
			frm: fr,
			activebg: "img/svg/pv_to_hp_bg_sel.svg",
			passivebg: "img/svg/pv_to_hp_bg.svg"
		};
	}
	else
	{
		p.hpprev=
		{
			name: "HP PREV",
			title: gui.newLabel (fr, 27, 234, 258, 14, '', prop.value_left),
			knob: gui.newPicture(fr, 13, 269,  18, 18, "img/pknob_18px.png"),
			list: gui.newList   (fr, 45, 249, 225, 60, '', prop.list),
			focus: monoptFocus
		};
	}
	p.hpprev.list.setProps({border:1});
	p.hpprev.title.setText("PREVIEW TO HEADPHONES");
	p.hpprev.list.insert("OFF", 1);
	p.hpprev.list.insert("ON (PREVIEW IN STEREO)", 2);
	p.hpprev.list.insert("SPLIT (SELECTION TO LEFT, PREVIEW TO RIGHT)", 3);
/* TODO: blend not implementd
	p.hpprev.list.insert("BLEND (MIXES PVW & SELECTION IN STEREO)", 4);
*/
	p.hpprev.list.select(0);
// Monitor Mode
	if(cfg_fusionUI)
	{
		fr=gui.newFrame(f, 0, 40+(120+9)*3, 312, 120, "img/svg/mon_opt_bg_passive.svg");
		gui.newFrame(fr, 312-10-20, 7, 20, 20, "img/svg/icon_pan_and_mode.svg");
		p.monmode=
		{
			name: "MO MODE",
			title: gui.newLabel(fr, x,  y, 108, 16, '', prop.value_left_medium),
			list:  gui.newList (fr, 312/2-292/2, y+4+16, 292, 84, '', prop.list),
			focus: monoptFocusFusion,
			frm: fr,
			activebg: "img/svg/mon_opt_bg_active.svg",
			passivebg: "img/svg/mon_opt_bg_passive.svg"
		};
	}
	else
	{
		p.monmode=
		{
			name: "MO MODE",
			title: gui.newLabel (fr, 27, 322, 108, 14, '', prop.value_left),
			knob: gui.newPicture(fr,  9, 359,  18, 18, "img/pknob_18px.png"),
			list: gui.newList   (fr, 32, 338, 108, 60, '', prop.list),
			focus: monoptFocus
		};
	}
	p.monmode.title.setText("MONITOR MODE");
	p.monmode.list.setProps({border:1});
	for(k in mode_txt)
	{
		p.monmode.list.insert(mode_txt[k], k);
		if(k>=4 && !cfg_surroundMode) break;
	}
	p.monmode.list.select(0);
// Headphone Mode
	if(cfg_fusionUI)
	{
		fr=gui.newFrame(f, 640-312, 40+(120+9)*3, 312, 120, "img/svg/mon_opt_bg_passive.svg");
		gui.newFrame(fr, 312-10-20, 7, 20, 20, "img/svg/icon_pan_and_mode.svg");
		p.hpmode=
		{
			name: "HP MODE",
			title: gui.newLabel(fr, x, y, 128, 16, '', prop.value_left_medium),
			list:  gui.newList (fr, 312/2-292/2, y+4+16, 292, 84, '', prop.list),
			focus: monoptFocusFusion,
			frm: fr,
			activebg: "img/svg/mon_opt_bg_active.svg",
			passivebg: "img/svg/mon_opt_bg_passive.svg"
		};
	}
	else
	{
		p.hpmode=
		{
			name: "HP MODE",
			title: gui.newLabel (fr, 193, 322, 108, 14, '', prop.value_left),
			knob: gui.newPicture(fr, 173, 359,  18, 18, "img/pknob_18px.png"),
			list: gui.newList   (fr, 198, 338, 108, 60, '', prop.list),
			focus: monoptFocus
		};
	}
	p.hpmode.title.setText("HEADPHONE MODE");
	p.hpmode.list.setProps({border:1});
	for(k in mode_txt)
	{
		p.hpmode.list.insert(mode_txt[k], k);
		if(k>=4 && !cfg_surroundMode) break;
	}
	p.hpmode.list.select(0);

	p.focuslist=
	[
		p.lev[0], p.lev[1], p.lev[2],
		p.hpfollow, p.hpproc, p.hpprev,
		p.monmode, p.hpmode
	];
	p.focus=-1;
	p.setFocus=function(newfocus)
	{
		if(newfocus==this.focus) return;
	// remove focus
		if(this.focus in this.focuslist) this.focuslist[this.focus].focus(false);
		this.focus=newfocus;
		if(this.focus in this.focuslist) this.focuslist[this.focus].focus(true);
	}

// softknobs
	p.sknobs6=
	[
		{enabled: true, push: "SELECT"},
		{enabled: true, rot: "HP LINK", push: "TAKE", list: p.hpfollow.list},
		{enabled: true, rot: "HP PROC", push: "TAKE", list: p.hpproc.list},
		{enabled: true, rot: "HP PREV", push: "TAKE", list: p.hpprev.list},
		{enabled: true, rot: "MO MODE", push: "TAKE", list: p.monmode.list},
		{enabled: true, rot: "HP MODE", push: "TAKE", list: p.hpmode.list}
	];
	p.sknobs3=
	[
		{enabled: false, updn: true, enter: true},
		{enabled: false},
		{enabled: true, rot: "FUNCTION", push: "EXIT", jog: true, ltrt: true}
	];

	// event functions
	p.onOpen=function(channel_nr)
	{
	// Indications
		mod.setMasterKeyLed(keys.MstMonOpt, 255);
		mod.setMasterKeyLed(keys.CmbMonOpt, 255);

		sknobsShow(mod.comboPresent()?this.sknobs3:this.sknobs6);
		sknobsSetOne(0, {angleNrm:0});

		this.setFocus(-1);
		sknobsSetOne(8, {angle: 180});

	// register receive msg handlers (should be done before we send request as not all answers will be in one msg)
		rxHandlersGlobal.monoptIndi=monoptIndi;

		var rmsg=host.sendCmsgRq({id:"NEST",
			mTTCR:{id:"READ", bGAIN:0},
			mCRMO:{id:"READ", bDIGN:0, bMODE:0},
			mSTMO:{id:"READ", bDIGN:0},
			mCRHP:{id:"READ", bPVMO:0, bMODE:0, bINDP:0}
		});
		if(rmsg!=null) monoptIndi(rmsg);
	}
	p.onClose=function()
	{
		sknobsHide();
		delete rxHandlersGlobal.monoptIndi;
		mod.setMasterKeyLed(keys.MstMonOpt, 0);
		mod.setMasterKeyLed(keys.CmbMonOpt, 0);
	}

// events
	p.onSoftKnobRot =monoptOnSoftKnobRot;
	p.onSoftKnobDown=monoptOnSoftKnobDown;
	p.onSoftKnobUp  =monoptOnSoftKnobUp;

// aditional functions
	p.updateKnobs=function()
	{
	// update sknobs on focus change
		if(this.focus in this.lev)
		{
			sknobsSetOne(0, {rot: "TALK LEV", angleNrm:this.lev[this.focus].angl});
			sknobsSetOne(6, {enabled: true, rot: "TALK LEV", push: null, angleNrm: this.lev[this.focus].angl, list: null});
		}
		else
		{
			sknobsSetOne(0, {angleNrm:0, rot: null});
			if(this.focus in this.focuslist)
			{
				sknobsSetOne(6, {enabled: true, rot: this.focuslist[this.focus].name, push: "TAKE", list: this.focuslist[this.focus].list});
			}
			else
				sknobsSetOne(6, {enabled: false, rot: null, push: null, angleNrm:0, list: null});
		}
	}
}

function monoptIndi(msg)
{
	var p=pages.monopt;

	if(('mTTCR' in msg) && ('wGAIN' in msg.mTTCR))
	{
		p.lev[0].gain=msg.mTTCR.wGAIN;
		p.lev[0].angl=knobSetValue(p.lev[0], p.lev[0].gain, talk_const);
	}
	if('mCRMO' in msg)
	{
		if('wDIGN' in msg.mCRMO)
		{
			p.lev[1].gain=msg.mCRMO.wDIGN;
			p.lev[1].angl=knobSetValue(p.lev[1], p.lev[1].gain, dim_const);
		}
		if('bMODE' in msg.mCRMO) setListActive(p.monmode.list, msg.mCRMO.bMODE);
	}
	if(('mSTMO' in msg) && ('wDIGN' in msg.mSTMO))
	{
		p.lev[2].gain=msg.mSTMO.wDIGN;
		p.lev[2].angl=knobSetValue(p.lev[2], p.lev[2].gain, dim_const);
	}
	if('mCRHP' in msg)
	{
		if('bPVMO' in msg.mCRHP) setListActive(p.hpprev.list, msg.mCRHP.bPVMO);
		if('bMODE' in msg.mCRHP) setListActive(p.hpmode.list, msg.mCRHP.bMODE);
		if('bINDP' in msg.mCRHP) setListActive(p.hpfollow.list, msg.mCRHP.bINDP);
	}

	if(p.focus in p.lev)
	{
		sknobsSetTwo(0, 6, {angleNrm:p.lev[p.focus].angl});
	}
}
function monoptOnSoftKnobRot(idx, delta)
{
	if(idx==9)
	{
	// change focus
		this.setFocus(clamp(this.focus+delta, 0, this.focuslist.length-1));
		sknobsSetOne(8, {angleNrm: this.focus/(this.focuslist.length-1)});
		this.updateKnobs();
		return;
	}

	switch(idx)
	{
	case 7:
	case 1:
		switch(this.focus)
		{
		case 0:
			host.sendNestCmsg('mTTCR', {id:"WRIN", wGAIN: valAdjust(this.lev[0].gain, delta, talk_const)});
			break;
		case 1:
			host.sendNestCmsg('mCRMO', {id:"WRIN", wDIGN: valAdjust(this.lev[1].gain, delta, dim_const)});
			break;
		case 2:
			host.sendNestCmsg('mSTMO', {id:"WRIN", wDIGN: valAdjust(this.lev[2].gain, delta, dim_const)});
			break;
		}
		break;
	}
	sknobsUpdate();
}
function monoptOnSoftKnobDown(idx)
{
	var newfocus;
	const ftable={3:2,4:3,5:4,6:5,7:6};

	if(idx==7)
	{
		if(this.focus in ftable)
			idx=ftable[this.focus];
		else
			return;
	}

	switch(idx)
	{
	case 1:
		if(this.focus in this.lev)
		{
		// move to next!
			newfocus=(this.focus+1);
			if(!(newfocus in this.lev)) newfocus=-1;
		}
		else
			newfocus=0;
		this.setFocus(newfocus);
		if(this.focus==-1)
			sknobsSetOne(8, {angle: 180});
		else
			sknobsSetOne(8, {angleNrm: this.focus/7});
		this.updateKnobs();
		break;
	case 2:
		host.sendNestCmsg('mCRHP', {id:"WRIN", bINDP:this.hpfollow.list.selId});
		break;
	case 4:
		host.sendNestCmsg('mCRHP', {id:"WRIN", bPVMO:this.hpprev.list.selId});
		break;
	case 5:
		host.sendNestCmsg('mCRMO', {id:"WRIN", bMODE:this.monmode.list.selId});
		break;
	case 6:
		host.sendNestCmsg('mCRHP', {id:"WRIN", bMODE:this.hpmode.list.selId});
		break;
	}
}
function monoptOnSoftKnobUp(idx)
{
	switch(idx)
	{
	case 7:
		if(this.focus!=4) break;
	/* fall-through */
	case 3:
		if(this.hpproc.list.selId==999)
			activatePage(pages.hpeq, null); //open EQ screen
		break;
	case 9: // Exit
		closePage(this, null);
		break;
	}
}
