// ------------------------ global monopt2 page ------------------------

function monopt2PageCreate()
{
	var p;
	var f, fr, n, name;

	p=Page_Create('monopt2', 'mopt', "MONITOR OPTIONS 2");
	f=p.frame;

	const x=9, y=9;

// Meter Sources, Element has frame for both options, Fusion has own frame for each
	if(!cfg_fusionUI) fr=gui.newFrame(f, 53, 35, 315, 83, "img/monopt_meter.png");

// Rightmost Meter Mode
	if(cfg_fusionUI)
	{
		fr=gui.newFrame(f, 640-312, 40, 312, 120, "img/svg/mon_opt_bg_passive.svg");
		gui.newFrame(fr, 312-10-26, 12, 26, 16, "img/svg/icon_meters.svg");
		p.rtmeter=
		{
			name: "MTR MODE",
			title: gui.newLabel(fr, x, y, 150, 16, '', prop.value_left_medium),
			list:  gui.newList (fr, 312/2-292/2, 120/2-32/2, 292, 44, '', prop.list),
			focus: monoptFocusFusion,
			frm: fr,
			activebg: "img/svg/mon_opt_bg_active.svg",
			passivebg: "img/svg/mon_opt_bg_passive.svg"
		};
		p.rtmeter.list.setProps({border:1});
		p.rtmeter.title.setText((cfg_surroundMode?"2nd":"4th")+" METER SOURCE");
	}
	else
	{
		p.rtmeter=
		{
			name: "MTR MODE",
			title: gui.newLabel  (fr, 38+138, 12, 120, 14, '', prop.value_left),
			knob:  gui.newPicture(fr, 10+138, 45,  18, 18, "img/pknob_18px.png"),
			list:  gui.newList   (fr, 38+138, 40, 120, 32, '', prop.list),
			focus: monoptFocus
		};
		p.rtmeter.list.setProps({border:1});
		p.rtmeter.title.setText((cfg_surroundMode?"2nd":"4th")+" Meter Source");
	}
	p.rtmeter.list.insert("Program "+(cfg_surroundMode?2:4), 1);
	p.rtmeter.list.insert("CR Monitor / Preview", 2);
	p.rtmeter.list.select(0);

// 3rd Meter Source
	if(cfg_fusionUI)
	{
		fr=gui.newFrame(f, 0, 40, 312, 120, "img/svg/mon_opt_bg_passive.svg");
		gui.newFrame(fr, 312-10-26, 12, 26, 16, "img/svg/icon_meters.svg");
		p.mtrxpgm3=
		{
			name: "PGM3 SRC",
			title: gui.newLabel(fr, x, y, 150, 16, '', prop.value_left_medium),
			list:  gui.newList (fr, 312/2-292/2, 120/2-64/2+8, 292, 64+12, '', prop.list),
			focus: monoptFocusFusion,
			frm: fr,
			activebg: "img/svg/mon_opt_bg_active.svg",
			passivebg: "img/svg/mon_opt_bg_passive.svg"
		};
		p.mtrxpgm3.list.setProps({border:1, barw: 3, font:fontSemiBold(9)});
		p.mtrxpgm3.title.setText("3rd METER SOURCE");
	}
	else
	{
		p.mtrxpgm3=
		{
			name: "PGM3 SRC",
			title: gui.newLabel  (fr, 48, 12, 100, 14, '', prop.value_left),
			knob:  gui.newPicture(fr, 10, 45,  18, 18, "img/pknob_18px.png"),
			list:  gui.newList   (fr, 38, 32, 100, 46, '', prop.list),
			focus: monoptFocus
		};
		p.mtrxpgm3.list.setProps({border:1, barw: 3});
		p.mtrxpgm3.title.setText("3rd Meter Source");
	}
	p.mtrxpgm3.list.insert("Program 3", 803);
	p.mtrxpgm3.list.insert("Record", 731);
	p.mtrxpgm3.list.insert("Phone", 732);
	p.mtrxpgm3.list.insert("External 1", 861);
	p.mtrxpgm3.list.insert("External 2", 862);
	p.mtrxpgm3.list.select(0);

// Meter Options, Element has frame for both options, Fusion has own frame for each
	if(!cfg_fusionUI) fr=gui.newFrame(f, 53, 122, 315, 83, "img/monopt_meter.png");

// Meter Ballistics
	if(cfg_fusionUI)
	{
		fr=gui.newFrame(f, 0, 40+120+9, 312, 120, "img/svg/mon_opt_bg_passive.svg");
		gui.newFrame(fr, 312-10-26, 12, 26, 16, "img/svg/icon_meters.svg");
		p.mtrbal=
		{
			name: "METER\nBALLISTICS",
			title: gui.newLabel(fr, x, y, 150, 16, '', prop.value_left_medium),
			list:  gui.newList (fr, 312/2-292/2, 120/2-64/2+8, 292, 64+12, '', prop.list),
			focus: monoptFocusFusion,
			frm: fr,
			activebg: "img/svg/mon_opt_bg_active.svg",
			passivebg: "img/svg/mon_opt_bg_passive.svg"
		};
		p.mtrbal.list.setProps({border:1, barw: 3, font:fontSemiBold(9)});
		p.mtrbal.title.setText("METER BALLISTICS");
	}
	else
	{
		p.mtrbal=
		{
			name: "METER\nBALLISTICS",
			title: gui.newLabel  (fr, 48, 12, 140, 14, '', prop.value_left),
			knob:  gui.newPicture(fr, 10, 45,  18, 18, "img/pknob_18px.png"),
			list:  gui.newList   (fr, 38, 32, 150, 46, '', prop.list),
			focus: monoptFocus
		};
		p.mtrbal.list.setProps({border:1, barw: 3});
		p.mtrbal.title.setText("Meter Ballistics");
	}
	p.mtrbal.list.insert("Full Scale VU", 0);
	p.mtrbal.list.insert("BBC Type PPM", 1);
	p.mtrbal.list.insert("DIN Type PPM", 2);
	p.mtrbal.list.insert("EBU Digital", 3);
	p.mtrbal.list.insert("NORDIC Type", 4);
	p.mtrbal.list.select(0);

// Meter Peaks
	if(cfg_fusionUI)
	{
		fr=gui.newFrame(f, 640-312, 40+120+9, 312, 120, "img/svg/mon_opt_bg_passive.svg");
		gui.newFrame(fr, 312-10-26, 12, 26, 16, "img/svg/icon_meters.svg");
		p.mtrpeaks=
		{
			name: "MTR PEAKS",
			title: gui.newLabel(fr, x, y, 150, 16, '', prop.value_left_medium),
			list:  gui.newList (fr, 312/2-292/2, 120/2-32/2, 292, 44, '', prop.list),
			focus: monoptFocusFusion,
			frm: fr,
			activebg: "img/svg/mon_opt_bg_active.svg",
			passivebg: "img/svg/mon_opt_bg_passive.svg"
		};
		p.mtrpeaks.list.setProps({border:1});
		p.mtrpeaks.title.setText("METER PEAKS");
	}
	else
	{
		p.mtrpeaks=
		{
			name: "MTR PEAKS",
			title: gui.newLabel  (fr, 38+190, 12, 65, 14, '', prop.value_left),
			knob:  gui.newPicture(fr, 10+190, 45, 18, 18, "img/pknob_18px.png"),
			list:  gui.newList   (fr, 38+190, 40, 65, 32, '', prop.list),
			focus: monoptFocus
		};
		p.mtrpeaks.list.setProps({border:1});
		p.mtrpeaks.title.setText("METER PEAKS");
	}
	p.mtrpeaks.list.insert("Show", 1);
	p.mtrpeaks.list.insert("Hide", 0);
	p.mtrpeaks.list.select(0);

// Send And Returns
	if(!cfg_fusionUI) fr=gui.newFrame(f, 53, 210, 316, 416, "img/monopt_menu2.png");
// Aux Send Masters
	if(cfg_fusionUI)
	{
		fr=gui.newFrame(f, 0, 40+(120+9)*2, 640, 120, "img/svg/aux_sends_bg.svg");
		fr.title=gui.newLabel(fr, x, y, 150, 16, '', prop.value_left_medium);
		fr.title.setText("AUX SEND MASTERS");
		gui.newFrame(fr, 640-10-21, 12, 21, 15, "img/svg/icon_aux_sends.svg");
	}

	p.auxSend=[];
	for(n=0; n<4; n++)
	{
		name=host.sprintf("SEND %c", 65+n); // 65 is an ASCII code for 'A'
		if(cfg_fusionUI)
		{
			p.auxSend[n]=
			{
				name:  name,
				tag:   host.sprintf("mSND%d", n+1),
				v_gain: 0,
				a_gain: 0,
				v_onoff: false,
				v_pview: false,
				onoff: gui.newLabel(fr, 640/2-(3*131+50)/2+n*131, 31, 50, 14, '', prop.value),
				knob:  knobCreate  (fr, 640/2-(3*131+50)/2+n*131, 45, 50, name),
				pview: gui.newLabel(fr, 640/2-(3*131+50)/2+n*131, 97, 50, 14, '', prop.value),
				frm: fr,
				activebg: "img/svg/aux_sends_bg_sel.svg",
				passivebg: "img/svg/aux_sends_bg.svg",
				focus: function(on)
				{
					var pr=on?prop.Focused:prop.Inactive;

					this.frm.setBg(on?this.activebg:this.passivebg);
					this.knob.focus(on);
					this.onoff.setProps(pr);
					this.pview.setProps(pr);
				}
			};
		}
		else
		{
			p.auxSend[n]=
			{
				name:  name,
				tag:   host.sprintf("mSND%d", n+1),
				v_gain: 0,
				a_gain: 0,
				v_onoff: false,
				v_pview: false,
				onoff: gui.newLabel(fr, 30+n*71, 31, 40, 14, '', prop.value),
				knob:  knobCreate  (fr, 30+n*71, 45, 40, name),
				pview: gui.newLabel(fr, 30+n*71, 97, 40, 14, '', prop.value),
				focus: function(on)
				{
					var pr=on?prop.Focused:prop.Inactive;

					this.knob.focus(on);
					this.onoff.setProps(pr);
					this.pview.setProps(pr);
				}
			};
		}
		p.auxSend[n].pview.setText("PREVIEW");
		p.auxSend[n].pview.hide();
	}

// Aux Returns
	p.auxRet=[];
	for(n=0; n<2; n++)
	{
		name=host.sprintf("RETURN %c", 65+n); // 65 is an ASCII code for 'A'
		if(cfg_fusionUI)
		{
			fr=gui.newFrame(f, n*(640-312), 40+(120+9)*3, 312, 120, "img/svg/mon_opt_bg_passive.svg");
			fr.title=gui.newLabel(fr, x, y, 150, 16, '', prop.value_left_medium);
			fr.title.setText("AUX "+name);

			gui.newFrame(fr, 312-10-20, 12, 21, 15, "img/svg/icon_aux_returns.svg");
			p.auxRet[n]=
			{
				name:  name,
				tag:   host.sprintf("mRET%d", n+1),
				v_gain: 0,
				a_gain: 0,
				v_onoff: false,
				v_pview: false,
				v_pgm: [0,0,0,0],
				onoff: gui.newLabel(fr,  88, 29, 48, 14, '', prop.value),
				knob:  knobCreate  (fr,  80, 46, 64, name),
				pview: gui.newLabel(fr,  14, 90, 50, 14, '', prop.value),
				list : gui.newList (fr, 162, 13, 76, 94, '', prop.list),
				frm: fr,
				activebg: "img/svg/mon_opt_bg_active.svg",
				passivebg: "img/svg/mon_opt_bg_passive.svg",
				focus: function(on)
				{
					var pr=on?prop.Focused:prop.Inactive;

					this.frm.setBg(on?this.activebg:this.passivebg);
					this.knob.focus(on);
					this.onoff.setProps(pr);
					this.pview.setProps(pr);
				}
			};
			p.auxRet[n].list.setProps({border:1, font:fontSemiBold(9)});
		}
		else
		{
			p.auxRet[n]=
			{
				name:  name,
				tag:   host.sprintf("mRET%d", n+1),
				v_gain: 0,
				a_gain: 0,
				v_onoff: false,
				v_pview: false,
				v_pgm: [0,0,0,0],
				onoff: gui.newLabel(fr, 30+n*142, 150, 40, 14, '', prop.value),
				knob:  knobCreate  (fr, 28+n*142, 169, 44, name),
				pview: gui.newLabel(fr, 30+n*142, 221, 40, 14, '', prop.value),
				list : gui.newList (fr, 85+n*142, 155, 70, 74, '', prop.list),
				focus: function(on)
				{
					var pr=on?prop.Focused:prop.Inactive;

					this.knob.focus(on);
					this.onoff.setProps(pr);
					this.pview.setProps(pr);
				}
			};
		}
		p.auxRet[n].list.insert("PGM1", 0);
		p.auxRet[n].list.insert("PGM2", 1);
		p.auxRet[n].list.insert("PGM3", 2);
		p.auxRet[n].list.insert("PGM4", 3);
		p.auxRet[n].list.insert("PREVIEW", 1000);
		p.auxRet[n].list.select(0);
		p.auxRet[n].pview.setText("PREVIEW");
		p.auxRet[n].pview.hide();
	}

	p.focuslist=
	[
		p.mtrxpgm3, p.rtmeter,
		p.mtrbal, p.mtrpeaks,
		p.auxSend[0], p.auxSend[1], p.auxSend[2], p.auxSend[3],
		p.auxRet[0], p.auxRet[1]
	];
	p.focus=-1;
	p.setFocus=function(newfocus)
	{
		if(newfocus==this.focus) return;
	// remove focus
		if(this.focus in this.focuslist) this.focuslist[this.focus].focus(false);
		this.focus=newfocus;
		if(this.focus in this.focuslist) this.focuslist[this.focus].focus(true);
	}

// softknobs
	p.sknobs3=
	[
		{enabled: false, updn: true, enter: true},
		{enabled: false},
		{enabled: true, rot: "FUNCTION", push: "EXIT", jog: true, ltrt: true}
	];

	// event functions
	p.onOpen=function(channel_nr)
	{
		var rmsg;
		var readRet={id:'READ', bMSGN:0, bONSW:0, bPREV:0, bPGM1:0, bPGM2:0, bPGM3:0, bPGM4:0};
		var readSnd={id:'READ', bMSGN:0, bONSW:0, bPREV:0};

	// Indications
		mod.setMasterKeyLed(keys.MstMonOpt, 255);
		mod.setMasterKeyLed(keys.CmbMonOpt, 255);

		sknobsShow(this.sknobs3);

		this.setFocus(-1);
		sknobsSetOne(8, {angle: 180});

	// register receive msg handlers
		rxHandlersGlobal.monopt2Indi=monopt2Indi;

		setListActive(this.mtrpeaks.list, host.cfgGetInteger('meter.showPeaks', 1));
		setListActive(this.mtrbal.list, host.cfgGetInteger('meter.ballistics', 0));

		var msg={id:'NEST', mRET1:readRet, mRET2:readRet, mSND1:readSnd, mSND2:readSnd, mSND3:readSnd, mSND4:readSnd};
		msg[right_mtr_tag]={id:'READ', bSRSW:0};
		msg.mMTRX={id:"READ", mPGM3:{bNSEL:0}};
		rmsg=host.sendCmsgRq(msg);
		if(rmsg!=null) monopt2Indi(rmsg);
	}
	p.onClose=function()
	{
		sknobsHide();
		delete rxHandlersGlobal.monopt2Indi;
		mod.setMasterKeyLed(keys.MstMonOpt, 0);
		mod.setMasterKeyLed(keys.CmbMonOpt, 0);
	}

// events
	p.onSoftKnobRot =monopt2OnSoftKnobRot;
	p.onSoftKnobDown=monopt2OnSoftKnobDown;
	p.onSoftKnobUp  =monopt2OnSoftKnobUp;

// aditional functions
	p.updateKnobs=function()
	{
		var props, obj;

	// update sknobs on focus change
		if(this.focus in this.focuslist)
		{
			obj=this.focuslist[this.focus]
			props={enabled: true, rot: obj.name};
			if(this.focus>=4 && this.focus<=9)
			{
				props.push="ON / OFF";
				props.angleNrm=obj.a_gain;
				props.list=null;
			}
			else
			{
				props.push="TAKE";
				props.list=obj.list;
			}
			sknobsSetOne(6, props);
			if(this.focus>=4 && this.focus<=7)
				sknobsSetOne(7, {enabled: true, push:"PREVIEW", rot: null, list: null});
			else if(this.focus>=8 && this.focus<=9)
				sknobsSetOne(7, {enabled: true, rot:"ASSIGN", list: obj.list, push:"TAKE"});
			else
				sknobsSetOne(7, {enabled: false, rot: null, push: null, list: null});
		}
		else
		{
			sknobsSetOne(6, {enabled: false, rot: null, push: null, angleNrm:0, list: null});
			sknobsSetOne(7, {enabled: false, rot: null, push: null, angleNrm:0, list: null});
		}
	}
}

function monopt2IndiSend(page, obj, msg)
{
	if('wMSGN' in msg)
	{
		obj.v_gain=msg.wMSGN;
		obj.a_gain=knobSetValue(obj.knob, obj.v_gain, aux_const);
		if((page.focus in page.focuslist) && page.focuslist[page.focus]==obj)
			sknobsSetOne(6, {angleNrm: obj.a_gain});
	}
	if('bONSW' in msg)
	{
		obj.v_onsw=msg.bONSW!=0;
		obj.onoff.setText(obj.v_onsw?"ON":"OFF");
	}
	if('bPREV' in msg)
	{
		obj.v_pview=msg.bPREV!=0;
		obj.pview.show(obj.v_pview);
	}
}
function monopt2RetAssign(obj, idx, val)
{
	obj.v_pgm[idx]=val;
	obj.list.goPos(idx);
	obj.list.icon =val;
	obj.list.flags=val;
}
function monopt2IndiRet(page, obj, msg)
{
	if('wMSGN' in msg)
	{
		obj.v_gain=msg.wMSGN;
		obj.a_gain=knobSetValue(obj.knob, obj.v_gain, aux_const);
		if((page.focus in page.focuslist) && page.focuslist[page.focus]==obj)
			sknobsSetOne(6, {angleNrm: obj.a_gain});
	}
	if('bONSW' in msg)
	{
		obj.v_onsw=msg.bONSW!=0;
		obj.onoff.setText(obj.v_onsw?"ON":"OFF");
	}
	if('bPREV' in msg)
	{
		obj.v_pview=msg.bPREV!=0;
		obj.pview.show(obj.v_pview);
	}
	if('bPGM1' in msg) monopt2RetAssign(obj, 0, msg.bPGM1?1:0);
	if('bPGM2' in msg) monopt2RetAssign(obj, 1, msg.bPGM2?1:0);
	if('bPGM3' in msg) monopt2RetAssign(obj, 2, msg.bPGM3?1:0);
	if('bPGM4' in msg) monopt2RetAssign(obj, 3, msg.bPGM4?1:0);
}
function monopt2Indi(msg)
{
	var p=pages.monopt2;
	var n, obj;

// Rightmost meter
	if(('mMET4' in msg) && ('bSRSW' in msg.mMET4))
		setListActive(p.rtmeter.list, msg.mMET4.bSRSW);
	else if(('mMET2' in msg) && ('bSRSW' in msg.mMET2))
		setListActive(p.rtmeter.list, msg.mMET2.bSRSW);
// PGM3 meter source
	if(('mMTRX' in msg) && ('mPGM3' in msg.mMTRX) && ('wNSEL' in msg.mMTRX.mPGM3))
		setListActive(p.mtrxpgm3.list, msg.mMTRX.mPGM3.wNSEL);
// Aux sends
	for(n=0; n<4; n++)
	{
		obj=p.auxSend[n];
		if(obj.tag in msg)
			monopt2IndiSend(p, obj, msg[obj.tag]);
	}
// Aux Returns
	for(n=0; n<2; n++)
	{
		obj=p.auxRet[n];
		if(obj.tag in msg)
			monopt2IndiRet(p, obj, msg[obj.tag]);
	}
}
function monopt2OnSoftKnobRot(idx, delta)
{
	var obj;

	if(idx==9)
	{
	// change focus
		this.setFocus(clamp(this.focus+delta, 0, this.focuslist.length-1));
		sknobsSetOne(8, {angleNrm: this.focus/(this.focuslist.length-1)});
		this.updateKnobs();
		return;
	}

	if(idx==7)
	{
		if(this.focus>=4 && this.focus<=7)
		{
		// Aux sends
			obj=this.auxSend[this.focus-4];
			host.sendNestCmsg(obj.tag, {id:'WRIN', wMSGN: valAdjust(obj.v_gain, delta, aux_const)});
		}
		else if(this.focus>=8 && this.focus<=9)
		{
		// Aux return
			obj=this.auxRet[this.focus-8];
			host.sendNestCmsg(obj.tag, {id:'WRIN', wMSGN: valAdjust(obj.v_gain, delta, aux_const)});
		}
	}
}
function monopt2OnSoftKnobDown(idx)
{
	var obj, ind;

	if(idx==7)
	{
		if(this.focus==0)
			host.sendNestCmsg('mMTRX', {id:"WRIN", mPGM3:{wNSEL:this.mtrxpgm3.list.selId}});
		else if(this.focus==1)
			host.sendNestCmsg(right_mtr_tag, {id:'WRIN', bSRSW:this.rtmeter.list.selId});
		else if(this.focus==2)
		{
			changeMeterBallistics(this.mtrbal.list.selId);
			setListActive(this.mtrbal.list, host.cfgGetInteger('meter.ballistics', 0));
		}
		else if(this.focus==3)
		{
			gui.setMeterPeaks(this.mtrpeaks.list.selId);
			setListActive(this.mtrpeaks.list, host.cfgGetInteger('meter.showPeaks', 1));
		}
		else if(this.focus>=4 && this.focus<=7)
		{
		// Aux sends
			obj=this.auxSend[this.focus-4];
			host.sendNestCmsg(obj.tag, {id:'WRIN', bONSW: obj.v_onsw?0:1});
		}
		else if(this.focus>=8 && this.focus<=9)
		{
		// Aux return
			obj=this.auxRet[this.focus-8];
			host.sendNestCmsg(obj.tag, {id:'WRIN', bONSW: obj.v_onsw?0:1});
		}
	}
	else if(idx==8)
	{
		if(this.focus>=4 && this.focus<=7)
		{
		// Aux sends
			obj=this.auxSend[this.focus-4];
			host.sendNestCmsg(obj.tag, {id:'WRIN', bPREV: 1});
		}
		else if(this.focus>=8 && this.focus<=9)
		{
		// Aux return
			obj=this.auxRet[this.focus-8];
			ind=obj.list.selId;
			if(ind==1000)
				host.sendNestCmsg(obj.tag, {id:'WRIN', bPREV: 1});
			else if(ind in obj.v_pgm)
			{
				var msg={id:'WRIN'}, val=obj.v_pgm[ind]==0?1:0;
				msg["bPGM"+(ind+1)]=val;
				host.sendNestCmsg(obj.tag, msg);
			}
		}
	}
}
function monopt2OnSoftKnobUp(idx)
{
	var obj;

	if(idx==8)
	{
		if(this.focus>=4 && this.focus<=7)
		{
		// Aux sends
			obj=this.auxSend[this.focus-4];
			host.sendNestCmsg(obj.tag, {id:'WRIN', bPREV: 0});
		}
		else if(this.focus>=8 && this.focus<=9)
		{
		// Aux return
			obj=this.auxRet[this.focus-8];
			if(obj.list.selId==1000)
				host.sendNestCmsg(obj.tag, {id:'WRIN', bPREV: 0});
		}
	}
	else if(idx==9)
		closePage(this, null);
}
